package user

import (
	"duoduo/models/mysql"
	"duoduo/models/user"
	"duoduo/tools"
	"duoduo/tools/app"
	"github.com/gin-gonic/gin"
)

func UpdateName(c *gin.Context) {
	var inData user.UpdateNameRequest

	var sqlData mysql.User
	//var wallet mysql.Wallet
	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	sqlData.OpenID = inData.OpenId
	sqlData.UpdateTime = tools.GetCurrntTimeStr()
	sqlData.NickName = inData.NickName
	sqlData.AvatarUrl = inData.AvatarUrl

	_, err = sqlData.UpdateName()
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}

	app.OK(c, nil, app.Success)
}
