package user

import (
	"duoduo/models/mysql"
	"duoduo/models/user"
	"duoduo/tools/app"
	"github.com/gin-gonic/gin"
)

func UserList(c *gin.Context) {
	var inData user.UserListRequest

	var user mysql.User

	var pageSize = 10
	var pageIndex = 1

	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	if inData.PageSize != 0 {
		pageSize = inData.PageSize
	}
	if inData.PageIndex != 0 {
		pageIndex = inData.PageIndex
	}

	user.OpenID = inData.OpenId
	userVal, count, err := user.GetOrderOpenIdList(pageSize, pageIndex, inData.Status)
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}
	for i := 0; i < len(userVal); i++ {
		///pages/image/my_fill1.png
		if userVal[i].AvatarUrl == "" {
			userVal[i].AvatarUrl = "/pages/image/my_fill1.png"
		}
		if userVal[i].NickName == "" {
			userVal[i].NickName = "用户暂未授权昵称获取"
		}
	}

	app.PageOK(c, userVal, count, pageIndex, pageSize, app.Success)

}
