package user

import (
	"duoduo/models/mysql"
	"duoduo/models/user"
	"duoduo/tools/app"
	"github.com/gin-gonic/gin"
)

func OpenIdGet(c *gin.Context) {
	var inData user.OpenIdGetRequest
	var outData user.OpenIdGetResponse
	var sqlData mysql.User
	//var wallet mysql.Wallet
	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	sqlData.OpenID = inData.OpenId

	userVal, err := sqlData.Get()
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}

	outData.User = userVal

	app.OK(c, outData, app.Success)

}
