package user

import (
	"duoduo/apis/pdd"
	"duoduo/conf"
	"duoduo/models/mysql"
	"duoduo/models/user"
	"duoduo/tools"
	"duoduo/tools/app"
	"fmt"
	"github.com/gin-gonic/gin"
)

func OpenIdSet(c *gin.Context) {
	var inData user.OpenIdSetRequest
	var outData user.OpenIdSetResponse
	var sqlData mysql.User
	var sql1 mysql.User
	//var wallet mysql.Wallet
	err := c.ShouldBindJSON(&inData)
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	confIni, err := conf.ConnIni()
	if err != nil {
		app.Error(c, 400, err, err.Error())
		return
	}

	url := fmt.Sprintf("https://api.weixin.qq.com/sns/jscode2session?appid=%s&secret=%s&js_code=%s&grant_type=authorization_code", confIni.MustValue("wx", "app_id"), confIni.MustValue("wx", "secret"), inData.Code)
	val, err := pdd.DuoDuoGet(url)
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}

	fmt.Print(val)
	err = tools.JsonUnmarshal(val, &outData)
	if err != nil {
		app.Error(c, 500, err, err.Error())
		return
	}
	if outData.Errcode != 0 {
		app.Error(c, outData.Errcode, err, outData.Errmsg)
		return
	}
	//查询数据
	sqlData.OpenID = outData.OpenId
	num := sqlData.GetNum()
	if num == 0 {
		if inData.OpenId != "" { //有上级
			sql1.OpenID = inData.OpenId
			val, err := sql1.Get()
			if err != nil {
				app.Error(c, 500, err, err.Error())
				return
			}
			//创建用户
			sqlData.CreateTime = tools.GetCurrntTimeStr()
			sqlData.UpdateTime = tools.GetCurrntTimeStr()
			sqlData.OpenIdOne = inData.OpenId
			sqlData.OpenIdTwo = val.OpenIdOne
			sqlData.Create()
		} else { //无上级用户
			//创建用户
			sqlData.CreateTime = tools.GetCurrntTimeStr()
			sqlData.UpdateTime = tools.GetCurrntTimeStr()
			sqlData.Create()
		}

	}

	app.OK(c, outData, app.Success)

}
