package pdd

import "github.com/shopspring/decimal"

type DdkGoodsRecommendGetRequest struct {
	PddDdkBase
	CatId       string `json:"cat_id"`       //猜你喜欢场景的商品类目，20100-百货，20200-母婴，20300-食品，20400-女装，20500-电器，20600-鞋包，20700-内衣，20800-美妆，20900-男装，21000-水果，21100-家纺，21200-文具,21300-运动,21400-虚拟,21500-汽车,21600-家装,21700-家具,21800-医药;
	ChannelType string `json:"channel_type"` //进宝频道推广商品: 1-今日销量榜,3-相似商品推荐,4-猜你喜欢(和进宝网站精选一致),5-实时热销榜,6-实时收益榜。默认值5
	Offset      string `json:"offset"`       //从多少位置开始请求；默认值 ： 0，offset需是limit的整数倍，仅支持整页翻页
	Limit       string `json:"limit"`        //一页请求数量；默认值 ： 20
	Pid         string `json:"pid"`          //推广位id
}

//type DdkGoodsRecommendGetResponse struct {
//}

type DdkGoodsRecommendGetResponse struct {
	GoodsBasicDetailResponse GoodsBasicDetailResponse `json:"goods_basic_detail_response"`
}
type List struct {
	CategoryName         string          `json:"category_name"`
	CouponRemainQuantity int             `json:"coupon_remain_quantity"`
	PromotionRate        int64           `json:"promotion_rate"`
	CatIds               []int           `json:"cat_ids"`
	CouponMinOrderAmount int             `json:"coupon_min_order_amount"`
	CategoryID           string          `json:"category_id"`
	MallID               int             `json:"mall_id"`
	MallName             string          `json:"mall_name"`
	CouponTotalQuantity  int             `json:"coupon_total_quantity"`
	MerchantType         string          `json:"merchant_type"`
	LgstTxt              string          `json:"lgst_txt"`
	GoodsName            string          `json:"goods_name"`
	SalesTip             string          `json:"sales_tip"`
	GoodsID              int64           `json:"goods_id"`
	PredictPromotionRate int             `json:"predict_promotion_rate"`
	DescTxt              string          `json:"desc_txt"`
	GoodsDesc            string          `json:"goods_desc"`
	OptName              string          `json:"opt_name"`
	ShareRate            int             `json:"share_rate"`
	GoodsThumbnailURL    string          `json:"goods_thumbnail_url"`
	OptIds               []int           `json:"opt_ids"`
	OptID                string          `json:"opt_id"`
	GoodsImageURL        string          `json:"goods_image_url"`
	ActivityTags         []int           `json:"activity_tags"`
	HasCoupon            bool            `json:"has_coupon"`
	MinNormalPrice       int             `json:"min_normal_price"`
	ServTxt              string          `json:"serv_txt"`
	UnifiedTags          []string        `json:"unified_tags"`
	CouponStartTime      int             `json:"coupon_start_time"`
	MinGroupPrice        int64           `json:"min_group_price"`
	CouponDiscount       int64           `json:"coupon_discount"`
	GoodsSign            string          `json:"goods_sign"`
	CouponEndTime        int             `json:"coupon_end_time"`
	ExtraCouponAmount    int             `json:"extra_coupon_amount,omitempty"`
	MinAmount            decimal.Decimal `json:"min_amount"`
	Rebate               decimal.Decimal `json:"rebate"`
}
type GoodsBasicDetailResponse struct {
	Total     int    `json:"total"`
	List      []List `json:"list"`
	RequestID string `json:"request_id"`
}
