package app

//错误码描述
const (
	Success                      = "成功" // 200
	Fail                         = "Fail"
	ServerError                  = "Server Error" //500
	ClientError                  = "Client Error" //400
	DatabaseError                = "Sql Error"
	RequestParamError            = "request parameters error"
	DataBaseError                = "网络异常请稍后重试"
	InputError                   = "参数解析错误"
	UserIdError                  = "用户ID不能为空"
	OriginalTransaction          = "原交易信息错误"
	ExtOrderIdAgain              = "本订单已经发起了订单退款"
	RefundUTourStatusAwaitTicket = "正在出票中，暂时不允许退款，请稍后再试。"
	TicketUsage                  = "门票订单中存在已使用门票，不允许改期升级。"
	UserPayError                 = "未支付或退款状态，不允许改期升级。"
	UTourStatusNotEqualTicket    = "只有已出票的订单允许改期升级"
	JsonUnmarshalError           = "json数据解析失败"
	JsonMarshalError             = "数据转换json失败"
	RescheduleCreateError        = "改期升级订单创建失败"
	RescheduleError              = "改期升级订单失败"
	PushRegisterError            = "推送注册失败"
)

const (
	// 通知分组类型
	GroupShare            = "share"            // 浏览/感兴趣
	GroupOrder            = "order"            // 订单通知
	GroupOrderTransaction = "orderTransaction" // 订单事务

	// 消息类型
	GroupShareMsgTypeBrowse                   = "browse"        // 浏览
	GroupShareMsgTypeInterested               = "interested"    // 感兴趣
	GroupOrderMsgTypeCreate                   = "create"        // 创建订单
	GroupOrderMsgTypeReject                   = "reject"        // 创建订单
	GroupOrderMsgTypeCancel                   = "cancel"        // 取消订单
	GroupOrderMsgTypeAffirm                   = "affirm"        // 确认订单
	GroupOrderMsgTypePending                  = "pending"       // 待支付
	GroupOrderMsgTypePaid                     = "paid"          // 已支付
	GroupOrderTransactionMsgTypeLeave         = "leave"         // 退团
	GroupOrderTransactionMsgTypeNegotiate     = "negotiate"     // 议价
	GroupOrderTransactionMsgTypeChangeTourist = "changeTourist" // 变更游
	GroupOrderMsgTypeFinalPay                 = "finalPay"      // 尾款支付
	GroupOrderMsgTypeRefunded                 = "refunded"      // 已退款
	GroupOrderMsgDepartureNotice              = "departureNotice"
)

//退款-改期交易类型

//订单表，众信订单状态
const (
	UTourStatusAwaitPay       = "1"  //待付款	1  创建订单
	UTourStatusAwaitTicket    = "2"  //待出票	2  创建订单后完成支付(发起支付回调成功后修改成待出票状态)
	UTourStatusTicket         = "3"  //已出票	3
	UTourStatusCancel         = "4"  //已取消	4  异常情况下进行取消
	UTourStatusRefunding      = "5"  //退款中	5
	UTourStatusRefundComplete = "6"  //退款完成	6
	UTourStatusRefundFail     = "7"  //退款失败	7
	UTourStatusChangeAwaitPay = "8"  //（改签）待付款	8
	UTourStatusResigning      = "9"  //改签中	9
	UTourStatusChangeComplete = "10" //已改签	10
	UTourStatusChangeFail     = "11" //改签失败	11
	UTourStatusUpgradeFail    = "12" //升级失败	12
	UTourStatusShutDown       = "13" //已关闭	13
)

//订单表 支付状态
const (
	UserPayStatusUnPay  = "1" //未支付
	UserPayStatusPay    = "2" //已支付
	UserPayStatusRefund = "3" //退款
)
